This patch changes the behaviour in SJOIN.  Normally, modes are always sent
as appearing from the local server on a netmerge.  This patch reverts that
behaviour so the real server is shown when serverhiding is disabled.

Lee H

--- m_sjoin.old	2003-01-29 00:05:25.000000000 +0000
+++ m_sjoin.c	2003-01-29 00:06:54.000000000 +0000
@@ -119,6 +119,7 @@
   static         char buf[2*BUFSIZE]; /* buffer for modes and prefix */
   static         char sjbuf_nhops[BUFSIZE]; /* buffer with halfops as @ */
   char           *p; /* pointer used making sjbuf */
+  const char *server_name = ConfigServerHide.hide_servers ? me.name : source_p->name;
   int hide_or_not;
   int i;
   dlink_node *m;
@@ -372,12 +373,12 @@
       if (top_chptr != NULL)
 	sendto_channel_local(ALL_MEMBERS,
 			     chptr, ":%s MODE %s %s %s",
-			     me.name,
+			     server_name,
 			     top_chptr->chname, modebuf, parabuf);
       else
 	sendto_channel_local(ALL_MEMBERS,
 			     chptr, ":%s MODE %s %s %s",
-			     me.name,
+			     server_name,
 			     chptr->chname, modebuf, parabuf);
     }
 
@@ -610,7 +611,7 @@
 	        *mbuf = '\0';
 		sendto_channel_local(hide_or_not, chptr,
 		                     ":%s MODE %s %s %s %s %s %s",
-				     me.name, RootChan(chptr)->chname,
+				     server_name, RootChan(chptr)->chname,
 				     modebuf,
 				     para[0], para[1], para[2], para[3]);
                 mbuf = modebuf;
@@ -642,7 +643,7 @@
           *mbuf = '\0';
           sendto_channel_local(hide_or_not, chptr,
                                ":%s MODE %s %s %s %s %s %s",
-                               me.name,
+                               server_name,
                                RootChan(chptr)->chname,
                                modebuf,
                                para[0],para[1],para[2],para[3]);
@@ -678,7 +679,7 @@
     {
       sendto_channel_local(hide_or_not, chptr,
                            ":%s MODE %s %s %s %s %s %s",
-                           me.name,
+                           server_name,
                            RootChan(chptr)->chname,
                            modebuf,
                            para[0], para[1], para[2], para[3]);
